﻿using SharpChat.Misuzu;
using SharpChat.Packet;
using System;
using System.Threading.Tasks;

namespace SharpChat.Commands {
    public class BanListCommand : IChatCommand {
        private readonly MisuzuClient Misuzu;

        public BanListCommand(MisuzuClient msz) {
            Misuzu = msz ?? throw new ArgumentNullException(nameof(msz));
        }

        public bool IsMatch(ChatCommandContext ctx) {
            return ctx.NameEquals("bans")
                || ctx.NameEquals("banned");
        }

        public void Dispatch(ChatCommandContext ctx) {
            if(!ctx.User.Can(ChatUserPermissions.BanUser | ChatUserPermissions.KickUser)) {
                ctx.Chat.SendTo(ctx.User, new LegacyCommandResponse(LCR.COMMAND_NOT_ALLOWED, true, $"/{ctx.Name}"));
                return;
            }

            Task.Run(async () => {
                ctx.Chat.SendTo(ctx.User, new BanListPacket(
                    await Misuzu.GetBanListAsync()
                ));
            }).Wait();
        }
    }
}
