﻿using SharpChat.Packet;

namespace SharpChat.Commands {
    public class PasswordChannelCommand : IChatCommand {
        public bool IsMatch(ChatCommandContext ctx) {
            return ctx.NameEquals("pwd")
                || ctx.NameEquals("password");
        }

        public void Dispatch(ChatCommandContext ctx) {
            if(!ctx.User.Can(ChatUserPermissions.SetChannelPassword) || ctx.Channel.Owner != ctx.User) {
                ctx.Chat.SendTo(ctx.User, new LegacyCommandResponse(LCR.COMMAND_NOT_ALLOWED, true, $"/{ctx.Name}"));
                return;
            }

            string chanPass = string.Join(' ', ctx.Args).Trim();

            if(string.IsNullOrWhiteSpace(chanPass))
                chanPass = string.Empty;

            lock(ctx.Chat.ChannelsAccess)
                ctx.Chat.UpdateChannel(ctx.Channel, password: chanPass);
            ctx.Chat.SendTo(ctx.User, new LegacyCommandResponse(LCR.CHANNEL_PASSWORD_CHANGED, false));
        }
    }
}
