﻿using System.Collections.Generic;
using System.Text;

namespace SharpChat.Packet {
    public class ChannelCreatePacket : ServerPacket {
        public ChatChannel Channel { get; private set; }

        public ChannelCreatePacket(ChatChannel channel) {
            Channel = channel;
        }

        public override IEnumerable<string> Pack() {
            StringBuilder sb = new();

            sb.Append('4');
            sb.Append('\t');
            sb.Append('0');
            sb.Append('\t');
            sb.Append(Channel.Pack());

            yield return sb.ToString();
        }
    }
}
