﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SharpChat.Packet {
    public class UserChannelForceJoinPacket : ServerPacket {
        public ChatChannel Channel { get; private set; }

        public UserChannelForceJoinPacket(ChatChannel channel) {
            Channel = channel ?? throw new ArgumentNullException(nameof(channel));
        }

        public override IEnumerable<string> Pack() {
            StringBuilder sb = new();

            sb.Append('5');
            sb.Append('\t');
            sb.Append('2');
            sb.Append('\t');
            sb.Append(Channel.Name);

            yield return sb.ToString();
        }
    }
}
